#ifndef _UNITINPUT_H_
#define _UNITINPUT_H_

#include "allegro.h"
#include "AddUnitTemplate.h"

//covers AI for the unit
//arena to determine if it's out of bounds

class Unit;
class UnitList;

class UnitInput {
 public:
  UnitInput ();
  UnitInput (UnitInput *);
  void setCounters ();

  void decideAction (Unit * thisUnit, UnitList * units);
  void locateTarget (Unit * thisUnit, UnitList * units);

  void homeTargetCorrect (Unit * thisUnit, UnitList * units);
  void attackP (Unit * thisUnit, UnitList * units);
  void walkAndWait (Unit * thisUnit, UnitList * units);

  ~UnitInput ();

  //behavior
  int targetAffiliation; //the affiliation of the target

  //walking forward
  int walkTime; //how long should it move forward?
  int walkWait; //how long should it wait for?

  //if the unit should home in on a target by move forward -> correct angle
  bool homeTargetAngleCorrection;
  int homeTimeInbetweenCorrection;
  fixed homeAngleCorrection; //how much should they correct by?

  //if the unit should periodically fire
  bool attackPeriodically;
  int attackPeriod;
  int attackPeriodIndex;

 protected:
  fixed walkingDir;
  bool targetLocated;
  Unit * targetUnit;

  bool walkingMode;
  int walkTimeCounter;
  int walkWaitCounter;

  int homeTimeInbetweenCorrectionCounter;
  int attackPeriodCounter;
};

#endif
