#include "allegro.h"

#include "UnitTemplate.h"
#include "UnitInput.h"
#include "gameConstants.h"
#include "AddUnitTemplate.h"

#include <vector>
#include <string>
using namespace std;

UnitTemplate :: UnitTemplate ()
{
  vecPics = new vector <vector <BITMAP *> *> (charAnimNum);

  vector <vector <BITMAP *> *>::iterator the_iterator;
  the_iterator = vecPics -> begin ();
  while(the_iterator < vecPics -> end()) {
    (*the_iterator) = new vector <BITMAP *> ();
    the_iterator++;
  }

  addedUnits = new vector <AddUnitTemplate *> (0);
  uI = new UnitInput;

  affiliation = 0;
  maxHP = 1000;
  timeToLive = -20;
  costOfAttack = 0;
  walkMag = ftofix (5.0);
  juiceForPlayer = 0;

  //unit's properties (ethereal, bounces, outofbounds, etc)
  unitPropertyHitbox = 0;
  unitPropertyDefense = 0;
  unitPropertyStatus = 0;
  unitPropertyPlayer = 0;
  moveType = moveTypeNormal;

  //damage
  hitkbDir = ftofix (0.0);
  hitkbMag = ftofix (0.0);
  hitkbDur = 0;
  damageDealt = 0;
  goodStatusDamage = new vector <int> (numGoodStatus, 0);
  badStatusDamage = new vector <int> (numBadStatus, 0);

  isThePC = false;
}

void UnitTemplate :: deleteBitmaps ()
{
  //delete bitmaps
  vector <vector <BITMAP *> *>::iterator iter1;
  vector <BITMAP *>::iterator iter2;

  iter1 = vecPics -> begin ();
  while(iter1 < vecPics -> end()) 
    {
      iter2 = (*iter1) -> begin ();

      while (iter2 < (*iter1) -> end ())
	{
	  destroy_bitmap (*iter2);
	  iter2++;
	}
      iter1++;
    }
}

UnitTemplate :: ~UnitTemplate ()
{
  deleteBitmaps ();
}

void UnitTemplate :: setStatus (vector <string> ss, int status)
{
  int i = 0, iMax = 0;
  vector <int> * vec = NULL;

  if (status == 0 && ss.size () < goodStatusDamage -> size ()) iMax = ss.size ();
  if (status == 0 && ss.size () >= goodStatusDamage -> size ()) iMax = goodStatusDamage -> size ();
  if (status == 1 && ss.size () < badStatusDamage -> size ()) iMax = ss.size ();
  if (status == 1 && ss.size () >= badStatusDamage -> size ()) iMax = badStatusDamage -> size ();

  if (status == 0)
    vec = goodStatusDamage;
  else if (status == 1)
    vec = badStatusDamage;

  if (vec != NULL)
    { for (i = 0; i < iMax; i ++)
      vec -> at (i) = atoi (ss.at (i).c_str ());
    }
}

vector <vector <BITMAP *> *> * UnitTemplate :: getVecPics ()
{ return vecPics;}
